import discord
from discord.ext import commands
from discord.ext.commands import Context

from cpl_core.logging import LoggerABC
from gismo_core.abc.command_abc import CommandABC
from gismo_core.abc.message_service_abc import MessageServiceABC


class BaseCommandService(CommandABC):

    def __init__(
        self,
        logger: LoggerABC,
        message_service: MessageServiceABC
    ):
        CommandABC.__init__(self)

        self._logger = logger
        self._message_service = message_service

        self._logger.trace(__name__, f'Loaded command service: {type(self).__name__}')

    @commands.command()
    async def ping(self, ctx: Context):
        self._logger.debug(__name__, f'Received command ping {ctx}')
        await self._message_service.send_ctx_msg(ctx, 'Pong')
